// TabPageTwo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Eapi.h"
#include "Eapi_Seco.h"
#include "TabPage3.h"
#include "EAPI_WINDlg.h"

// CTabPageThree dialog

IMPLEMENT_DYNAMIC(CTabPageThree, CDialog)
CTabPageThree::CTabPageThree(CWnd* pParent /*=NULL*/)
	: CDialog(CTabPageThree::IDD, pParent)
	, m_Data_String(_T("00"))
	, m_DevAdd_String(_T("00"))
	, m_Reg_String(_T("00"))
	, m_I2C_Mode(0)
{
}

CTabPageThree::~CTabPageThree()
{
}

void CTabPageThree::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_I2C_DATA_STRING, m_Data_String);
	DDX_Text(pDX, IDC_I2C_DEVADD_STRING, m_DevAdd_String);
	DDX_Text(pDX, IDC_I2C_REG_STRING, m_Reg_String);
	DDV_MaxChars(pDX, m_Data_String, 128);
	DDV_MaxChars(pDX, m_DevAdd_String, 2);
	DDV_MaxChars(pDX, m_Reg_String, 2);
	DDX_Radio(pDX, IDC_I2C_EXTERNAL, m_I2C_Mode);
}


BEGIN_MESSAGE_MAP(CTabPageThree, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_I2C_READ, OnBnClickedI2cRead)
	ON_BN_CLICKED(IDC_I2C_WRITE, OnBnClickedI2cWrite)	
	ON_BN_CLICKED(IDC_I2C_READ_REG, OnBnClickedI2cReadReg)
	ON_BN_CLICKED(IDC_I2C_WRITE_REG, OnBnClickedI2cWriteReg)
END_MESSAGE_MAP()


// CTabPageThree message handlers

void CTabPageThree::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here

}

void CTabPageThree::PrintReturn(unsigned long dwRet)
{
	char msg[1024];

	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(TEXT("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(TEXT("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(TEXT("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, TEXT("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
}

void CTabPageThree::OnBnClickedI2cRead()
{
	unsigned char Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned char bRead = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Error"), 0, 0);
		return;
	}

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}		

	dwRet = EApiI2CWriteReadRaw(	I2C_Mode, 
									Dev_Add_Byte, 
									NULL,
									0,
									&bRead,
									sizeof(unsigned char),
									1);
	PrintReturn(dwRet);
	
	m_Data_String.Format("%02X",bRead);

	UpdateData(false);
}


void CTabPageThree::OnBnClickedI2cWrite()
{
	unsigned char Dev_Add_Byte;
	uint32_t	  bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	unsigned char DataBuffer[LEN_MAX_BYTE_BUFFER];

	UpdateData(true);

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexStringToUnsignedChar(m_Data_String, DataBuffer, &LenBufferFind))
	{
		MessageBox(TEXT("Data Field Error"), 0, 0);
		return;
	}

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	dwRet = EApiI2CWriteReadRaw(	I2C_Mode, 
									Dev_Add_Byte, 
									DataBuffer,
									LenBufferFind,
									NULL,
									0,
									0);
	PrintReturn(dwRet);
	
	UpdateData(false);
}


void CTabPageThree::OnBnClickedI2cReadReg()
{
	unsigned char bRead = 0;
	unsigned char Dev_Add_Byte;
	unsigned char Reg_Byte;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_Reg_String, &Reg_Byte))
	{
		MessageBox(TEXT("Reg Address Field Error"), 0, 0);
		return;
	}

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	dwRet =  EApiI2CReadTransfer(	I2C_Mode, 
									Dev_Add_Byte, 
									Reg_Byte,
									&bRead,
									sizeof(bRead),
									1);
	PrintReturn(dwRet);
	
	m_Data_String.Format("%02X",bRead);

	UpdateData(false);
}

void CTabPageThree::OnBnClickedI2cWriteReg()
{
	unsigned char Dev_Add_Byte;
	unsigned char Reg_Byte;
	unsigned char Data_Byte;
	unsigned long dwLen = 1;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	if(!HexByteString2UnsignedChar(m_Data_String, &Data_Byte))
	{
		MessageBox(TEXT("Data Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_Reg_String, &Reg_Byte))
	{
		MessageBox(TEXT("Reg Address Field Error"), 0, 0);
		return;
	}

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	dwRet = EApiI2CWriteTransfer(	I2C_Mode, 
									Dev_Add_Byte, 
									Reg_Byte,
									&Data_Byte,
									1);	
	PrintReturn(dwRet);
	
	UpdateData(false);
}

